<template>
	<!--CERRAR -->
	<div class="row" v-show="!data.isLoading">
		<div class="col-12 mb-3">
			<button
				type="button"
				@click="close()"
				class="btn btn-secondary mb-2 pt-0 pb-0 px-1"
				style="float: right"
				title="Cerrar"
				alt="Cerrar"
			>
				<i class="bi bi-x-square p-1 px-1"></i>
			</button>
		</div>

		<!-- LEGALES -->

		<div class="col-12">
			<div
				class="row position-relative"
				style="border: 1px solid #ccc; padding: 30px"
			>
				<div class="col-12">
					<FormularioLegales
						ref="formLegales"
						:titulo="data.titulo"
						:isLoading="data.isLoading"
					/>
				</div>
			</div>
		</div>

		<!-- DGA -->
		<div class="col-12 mt-5" v-show="accion == 'M'">
			<div
				class="row position-relative"
				style="border: 1px solid #ccc; padding: 30px"
			>
				<div class="col-12">
					<FormularioDga ref="formDGA" :titulo="data.titulo" />
				</div>
			</div>
		</div>

		<!-- OBSERVACIONES -->
		<div
			class="col-12 mt-5"
			style="border: 1px solid #ccc; padding: 30px"
			v-show="accion == 'M'"
		>
			<FormularioObservaciones :titulo="data.titulo" ref="formObservaciones" />
		</div>
	</div>
</template>

<script lang="ts">
// Libraries
import { reactive, ref, computed } from "vue";
import Swal from "sweetalert2/dist/sweetalert2.js";
import { useRoute, useRouter } from "vue-router";
import shared from "@/shared.js";
const { isEmpty, loading } = shared();

// Components
import FormularioLegales from "@/components/formulario/FormularioLegales.vue";
import FormularioDga from "@/components/formulario/FormularioDga.vue";
import FormularioObservaciones from "@/components/formulario/FormularioObservaciones.vue";

// Entities
import type { Titulo } from "@/entities/Titulo";

// Stores
import { useTitulosStore } from "@/stores/titulos";
import { useAuxFormDataStore } from "@/stores/auxFormData";

export default {
	components: { FormularioLegales, FormularioDga, FormularioObservaciones },

	setup() {
		const route = useRoute();
		const router = useRouter();
		const titulosStore = useTitulosStore();
		const auxFormDataStore = useAuxFormDataStore();

		var data = reactive({
			titulo: undefined as Titulo | undefined,
			isLoading: true,
		});

		// REFS
		const formLegales = ref<InstanceType<typeof FormularioLegales> | null>(
			null
		);
		const formDGA = ref<InstanceType<typeof FormularioDga> | null>(null);
		const formObservaciones = ref<InstanceType<
			typeof FormularioObservaciones
		> | null>(null);

		// #region COMPUTED

		const accion = computed(() => {
			return typeof data.titulo === "undefined" ? "A" : "M";
		});

		// #endregion

		// expose to template and other options API hooks
		return {
			route,
			router,
			data,
			// STORES
			titulosStore,
			auxFormDataStore,
			// COMPUTED
			accion,
			// REFS
			formLegales,
			formDGA,
			formObservaciones,
		};
	},

	async mounted() {
		loading.show();
		this.data.isLoading = true;
		try {
			await Promise.all([
				this.auxFormDataStore.getTiposDoc(),
				this.auxFormDataStore.getNormativaVigente(),
			]);

			// Al cargar la instancia del componente por primera vez
			await this.loadTituloEjecutivo(this.route.params.id);

			loading.hide();
			this.data.isLoading = false;
		} catch (error: any) {
			console.log(error);
			loading.hide();
			Swal.fire({
				icon: "error",
				text: "Ocurrio un error al cargar datos de la aplicación",
			});
		}
	},

	// Vue Router Component Guards --> Permite actualizar el componente cuando cambian los parámetros de la ruta
	async beforeRouteUpdate(to) {
		this.data.isLoading = true;
		await this.loadTituloEjecutivo(to.params.id);
		this.data.isLoading = false;
	},

	methods: {
		close() {
			this.formLegales?.initForm();
			this.formDGA?.initForm();
			this.formObservaciones?.initForm();
			this.router.push({ name: "listado" });
		},
		async loadTituloEjecutivo(id_titulo_ejec: string | string[]) {
			if (!isEmpty(id_titulo_ejec) && typeof id_titulo_ejec === "string") {
				var id: number = parseInt(id_titulo_ejec);
				this.data.titulo = await this.titulosStore.findTituloById(id, true);
			}
		},
	},
};
</script>

<!-- Add "scoped" attribute to limit CSS to this component only -->
<style scoped></style>
